package com.windshare.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.ImageView
import android.widget.TextView
import com.windshare.ShareModel
import wind.adf.R

/**
 * # ***********************************************************************************************
 * # ClassName:      ShareMenuAdapter$
 * # Function:       分享菜单适配器
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2020/3/12$    16:02$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class ShareMenuAdapter(val context: Context) : BaseAdapter() {

    private val mInflater by lazy { LayoutInflater.from(context) }

    private val mData = mutableListOf<ShareModel>()

    fun setData(data: MutableList<ShareModel>?) {
        mData.clear()
        data?.let {
            mData.addAll(it)
        }
    }

    override fun getView(position: Int, convertView: View?, parent: ViewGroup?): View {
        val view: View
        val viewHolder: ViewHolder
        if (convertView == null) {
            view = mInflater.inflate(R.layout.adf_view_share_item, parent, false)
            viewHolder = ViewHolder(view)
            view.tag = viewHolder
        } else {
            viewHolder = convertView.tag as ViewHolder
            view = convertView
        }
        val item = getItem(position)
        item?.let {
            viewHolder.shareIcon.setImageResource(it.imageResId)
            viewHolder.shareName.text = it.name
        }
        return view
    }

    override fun getItem(position: Int): ShareModel? {
        return mData.elementAtOrNull(position)
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    override fun getCount(): Int {
        return mData.size
    }

    private class ViewHolder(view: View) {
        val shareIcon: ImageView =view.findViewById(R.id.adf_share_iv)
        val shareName: TextView =view.findViewById(R.id.adf_share_tv)
    }
}