package kotlinextend

import android.text.Editable
import android.text.TextWatcher

/**
 * # **********************************************************************************************
 * # ClassName:      TextWatcherImpl
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/12/6    13:39
 * # Modifications:  initial
 * # **********************************************************************************************
 */

class TextWatcherImpl : TextWatcher {
    private var afterTextChangedFunValue: ((Editable?) -> Unit)? = null
    private var beforeTextChangedFunValue: ((CharSequence?, Int, Int, Int) -> Unit)? = null
    private var onTextChangedFunValue: ((CharSequence?, Int, Int, Int) -> Unit)? = null
    fun afterTextChangedFun(afterTextChangedFun: (s: Editable?) -> Unit) {
        afterTextChangedFunValue = afterTextChangedFun
    }

    fun beforeTextChangedFun(beforeTextChangedFun: (s: CharSequence?, start: Int, count: Int, after: Int) -> Unit) {
        beforeTextChangedFunValue = beforeTextChangedFun
    }

    fun onTextChangedFun(onTextChangedFun: (s: CharSequence?, start: Int, before: Int, count: Int) -> Unit) {
        onTextChangedFunValue = onTextChangedFun
    }

    override fun afterTextChanged(s: Editable?) {
        afterTextChangedFunValue?.invoke(s)
    }

    override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
        beforeTextChangedFunValue?.invoke(s, start, count, after)
    }

    override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
        onTextChangedFunValue?.invoke(s, start, before, count)
    }
}