package wind.android.bussiness.strategy.limitupseizeup.fragment

import android.content.Intent
import android.content.res.Configuration
import android.os.Message
import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.util.TypedValue
import android.view.Gravity
import android.view.MotionEvent
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.jcodecraeer.xrecyclerview.XRecyclerView
import eventinterface.TouchEventListener
import kotlinx.android.synthetic.main.limit_up_frag.*
import session.F5Session
import useraction.SkyUserAction
import useraction.UserActionReader
import util.StringUtils
import util.ThemeUtils
import util.ToastTool
import wind.android.R
import wind.android.bussiness.optionalstock.preopt.view.RecyclerViewDivider
import wind.android.bussiness.optionalstock.util.UserActionFunctionId
import wind.android.bussiness.optionalstock.util.UserActionFunctionId.LIMIT_UP_ADD_OPTIONAL
import wind.android.bussiness.strategy.activity.StockTagDetailActivity
import wind.android.bussiness.strategy.adapter.CommonViewHolder
import wind.android.bussiness.strategy.limitupseizeup.*
import wind.android.bussiness.strategy.limitupseizeup.adapter.LimitMainPowerAdapter
import wind.android.bussiness.strategy.limitupseizeup.bean.LimitMessageEvent
import wind.android.bussiness.strategy.limitupseizeup.bean.LimitTopicModel
import wind.android.bussiness.strategy.limitupseizeup.bean.LimitUpDetailModel
import wind.android.bussiness.strategy.limitupseizeup.presenter.LimitUpFragPresenter
import wind.android.bussiness.strategy.limitupseizeup.view.ILimitFragView
import wind.android.bussiness.strategy.view.HorizontalSlipRecyclerView
import wind.android.f5.activity.SpeedDetailActivity
import wind.android.f5.activity.SpeedDetailLandActivity
import wind.android.f5.model.LittleTrendModel
import wind.android.market.view.SortTextViewEx

/**
 * # **********************************************************************************************
 * # ClassName:      LimitMainPowerFrag
 * # Description:    涨停捉妖---主力数据列表
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/10/17    17:02
 * # Modifications:  initial
 * # **********************************************************************************************
 */

class LimitMainPowerFrag : BaseLimitUpFrag<LimitUpFragPresenter>(), XRecyclerView.LoadingListener,
        View.OnClickListener, CommonViewHolder.OnItemCommonClickListener,
        LimitMainPowerAdapter.OnLocalViewClickListener, TouchEventListener {

    protected lateinit var mRightGroup: LinearLayout
    private lateinit var mAdapter: LimitMainPowerAdapter
    private val mDataModels = mutableListOf<LimitUpDetailModel?>()
    private val mSortTextViewList = mutableListOf<SortTextViewEx>()
    override fun getLayoutId(): Int {
        return R.layout.limit_up_frag
    }

    override fun createPresenter(): LimitUpFragPresenter {
        return LimitUpFragPresenter(this, LIMIT_UP_MAIN_POWER)
    }

    override fun init() {
        hrecyclerview.addItemDecoration(RecyclerViewDivider(activity, LinearLayoutManager.HORIZONTAL,
                1, ThemeUtils.getColor(resources, R.color.color_line_setting_black,
                R.color.color_line_setting_white), true))
        hrecyclerview.setFooterViewTextColor(ThemeUtils.getColor(resources, R.color.txt_color_black_2,
                R.color.txt_color_white_2))
        hrecyclerview.setLoadingListener(this)
        hrecyclerview.setLoadingMoreEnabled(false)
        hrecyclerview.closeAnimation()
        initListTitleView(hrecyclerview)
        limit_refresh_btn.setOnClickListener(this)
        mAdapter = LimitMainPowerAdapter(activity)
        mAdapter.setCommonClickListener(this)
        mAdapter.setOnLocalViewClickListener(this)
        mAdapter.setTrendItemListener(this)
        mAdapter.setLastDate(mLastDate)
        hrecyclerview.setAdapter(mAdapter)
    }

    /**
     * 初始化列表标题部分
     */
    private fun initListTitleView(horizontalSlipRecyclerView: HorizontalSlipRecyclerView) {
        val sortList = getTabLimits(LIMIT_UP_MAIN_POWER)

        val leftTextView = TextView(activity)
        leftTextView.text = getString(R.string.limit_up_stock_name)
        leftTextView.gravity = Gravity.CENTER
        leftTextView.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 13f)
        leftTextView.setTextColor(ThemeUtils.getColor(-0x6a6a6b, -0x8f8f90))

        mRightGroup = LinearLayout(activity)
        mRightGroup.orientation = LinearLayout.HORIZONTAL
        mRightGroup.gravity = Gravity.CENTER_VERTICAL
        val params = LinearLayout.LayoutParams(StringUtils.dipToPx(85f), LinearLayout.LayoutParams.MATCH_PARENT)
        val sortParams = LinearLayout.LayoutParams(StringUtils.dipToPx(69f), LinearLayout.LayoutParams.MATCH_PARENT)
        val imageParams = LinearLayout.LayoutParams(StringUtils.dipToPx(16f), StringUtils.dipToPx(15f))
        imageParams.setMargins(StringUtils.dipToPx(2f), 0, StringUtils.dipToPx(2f), 0)
        for (item in sortList) {
            if (item.hasTip) {
                val layout = LinearLayout(activity)
                layout.orientation = LinearLayout.HORIZONTAL
                layout.gravity = Gravity.CENTER_VERTICAL
                layout.tag = item
                val sortText = SortTextViewEx(activity)
                setSortText(sortText, item)
                val imageView = ImageView(activity)
                imageView.setImageResource(R.drawable.limit_question_mark)
                imageView.setOnClickListener(this)
                imageView.tag = item
                layout.addView(sortText, sortParams)
                layout.addView(imageView, imageParams)
                mRightGroup.addView(layout, params)
                if (item.index == SORT_TODAY_CHANGE || item.index == SORT_UP_TO_CHANGE) {
                    layout.visibility = if (mLastDate) View.GONE else View.VISIBLE
                }
            } else {
                val sortText = SortTextViewEx(activity)
                setSortText(sortText, item)
                mRightGroup.addView(sortText, params)
                if (item.index == SORT_TODAY_CHANGE || item.index == SORT_UP_TO_CHANGE) {
                    sortText.visibility = if (mLastDate) View.GONE else View.VISIBLE
                }
            }
        }
        horizontalSlipRecyclerView.setTitleLayout(StringUtils.dipToPx(35f), leftTextView,
                StringUtils.dipToPx(150f), mRightGroup)
        horizontalSlipRecyclerView.setTitleLayoutBackground(ThemeUtils.getResId(R.drawable.view_bg_black_color, R.color.limit_title_bg_white))
    }

    /**
     * 设置可排序标题参数
     */
    private fun setSortText(sortTextViewEx: SortTextViewEx, item: LimitSort) {
        sortTextViewEx.setText(item.value)
        sortTextViewEx.setTextSize(13)
        sortTextViewEx.isCenter = !item.hasTip
        sortTextViewEx.setTouchEventListener(this)
        sortTextViewEx.tag = item
        mSortTextViewList.add(sortTextViewEx)
    }

    override fun handleMessage(msg: Message?) {
        super.handleMessage(msg)
        when (msg?.what) {
            ERROR_MSG -> {
                hrecyclerview.refreshComplete()
                mDataModels.clear()
                mAdapter.setData(mDataModels)
                mAdapter.notifyDataSetChanged()
                list_tip.visibility = View.GONE
                open_tip_layout.visibility = View.GONE
                error_tip_layout.visibility = View.VISIBLE
            }
            RESULT_MSG -> {
                hrecyclerview.refreshComplete()
                open_tip_layout.visibility = View.GONE
                error_tip_layout.visibility = View.GONE
                val list = msg.obj as List<LimitUpDetailModel>
                mDataModels.clear()
                mDataModels.addAll(list)
                mAdapter.setData(mDataModels)
                if (mDataModels.isEmpty()) {
                    list_tip.visibility = View.VISIBLE
                } else {
                    list_tip.visibility = View.GONE
                }
                mAdapter.notifyDataSetChanged()
            }
            UPDATE_LIST_PART_MSG -> {
                val position = msg.arg1
                @ILimitFragView.UpdateType val type = msg.arg2
                if (position < mDataModels.size) {
                    val limitUpDetailModel = mDataModels[position]
                    limitUpDetailModel?.let {
                        if (type == ILimitFragView.ADD_OPT_STOCK) {
                            it.isCurGroupOptStock = true
                            it.isOptionalStock = true
                        } else if (type == ILimitFragView.DEL_OPT_STOCK) {
                            it.isCurGroupOptStock = false
                            it.isOptionalStock = false
                        }
                    }
                    //有下拉刷新的头，所以position + 1
                    mAdapter.notifyItemChanged(position + 1)
                }
            }
            UPDATE_LIST_OPEN_TIP -> {
                mDataModels.clear()
                mAdapter.setData(mDataModels)
                mAdapter.notifyDataSetChanged()
                list_tip.visibility = View.GONE
                error_tip_layout.visibility = View.GONE
                open_tip_layout.visibility = View.VISIBLE
            }
            UPDATE_LIST_TITLE -> {
//                if (mPermission) {
//                    titleChangeRate.visibility = View.VISIBLE
//                    titleListedStock.visibility = View.VISIBLE
//                    titlePrice.visibility = View.VISIBLE
//                    titleStatus.visibility = View.VISIBLE
//                    titleTurnoverRate.visibility = View.VISIBLE
//                } else {
//                    titleChangeRate.visibility = View.GONE
//                    titleListedStock.visibility = View.GONE
//                    titlePrice.visibility = View.GONE
//                    titleStatus.visibility = View.GONE
//                    titleTurnoverRate.visibility = View.GONE
//                }
//                hrecyclerview.invalidRightTitle()
            }
            SHOW_TIP_MSG -> {
                hrecyclerview.refreshComplete()
                ToastTool.showToast(msg.obj as String)
            }
            RESET_LIST_TITLE -> {
                initListTitleView(hrecyclerview)
                hrecyclerview.setAdapter(mAdapter)
            }
        }
    }

    override fun isRegisterEventBus(): Boolean {
        return true
    }

    override fun onFragHide(byOnPause: Boolean) {
        mPresenter.releaseOptionalOperateListener()
    }

    override fun onFragShow(byOnResume: Boolean) {
        mPresenter.setOptionalOperateListener()
        if (!byOnResume) {
            mPresenter.reqLimitDetail()
        }
    }

    override fun onDateChange(date: String?) {
        if (mFragVisible) {
            mPresenter.reqLimitDetailByDate(date)
        } else {
            mPresenter.setDate(date)
        }
    }

    override fun onStockFilterChange(filterIdList: MutableList<Int>) {
        if (mFragVisible) {
            mPresenter.reqLimitDetailByFilterId(filterIdList)
        } else {
            mPresenter.setStockFilterIds(filterIdList)
        }
    }

    override fun onTopicIdsChange(topicIdList: MutableList<Int>) {
        if (mFragVisible) {
            mPresenter.reqLimitDetailByTopicId(topicIdList)
        } else {
            mPresenter.setTopicIds(topicIdList)
        }
    }

    override fun onFilterOptional(filterOptional: Boolean) {
        if (mFragVisible) {
            mPresenter.filterOptional(filterOptional, mDataModels)
        } else {
            mPresenter.setFilterOptional(filterOptional)
        }
    }

    override fun onActNoStickyMsg(messageEvent: LimitMessageEvent) {
        if (mFragVisible) {
            val messageId = messageEvent.getmMessageId()
            if (messageId == LimitMessageEvent.MESSAGE_LIMIT_OPEN_TIP) {
                sendEmptyMessage(UPDATE_LIST_OPEN_TIP)
            } else if (messageId == LimitMessageEvent.MESSAGE_LIMIT_LIST_TITLE) {
                sendEmptyMessage(RESET_LIST_TITLE)
            }
        }
    }

    override fun onUpdateListAll(list: MutableList<LimitUpDetailModel?>?) {
        val result = mutableListOf<LimitUpDetailModel?>()
        list?.let { result.addAll(it) }
        val msg = Message.obtain()
        msg.what = RESULT_MSG
        msg.obj = result
        sendMessage(msg)
    }

    override fun onUpdateListByPosition(position: Int, type: Int) {
        val msg = Message.obtain()
        msg.what = UPDATE_LIST_PART_MSG
        msg.arg1 = position
        msg.arg2 = type
        sendMessage(msg)
    }

    override fun onUpdateLittleTrend(model: LittleTrendModel?) {
        post {
            model?.let {
                // 根据model计算对应的position
                for (i in 0 until mAdapter.itemCount) {
                    if (!TextUtils.isEmpty(mAdapter.getItem(i).windCode) && mAdapter.getItem(i).windCode == it.mLittleWindCode) {
                        mAdapter.getItem(i).mLittleTrendModel = it
                        //有下拉刷新的头，所以position + 1
                        mAdapter.notifyItemChanged(i + 1)
                        return@let
                    }
                }
            }
        }
    }

    override fun onUpdatePermission(isPermission: Boolean) {
        if (mPermission != isPermission) {
            mPermission = isPermission
            sendEmptyMessage(UPDATE_LIST_TITLE)
        }
    }

    override fun onError(errorType: Int, errorMsg: String?) {
        val msg = Message.obtain()
        msg.what = ERROR_MSG
        msg.arg1 = errorType
        sendMessage(msg)
    }

    override fun onShowTip(tip: String?) {
        val msg = Message.obtain()
        msg.what = SHOW_TIP_MSG
        msg.obj = tip
        sendMessage(msg)
    }

    override fun onShowProgressMum() {
        showProgressMum()
    }

    override fun onHideProgressMum() {
        hideProgressMum()
    }

    override fun onAddBtnClick(position: Int) {
        if (position >= 0 && position < mDataModels.size) {
            val item = mDataModels[position]
            if (mPermission) {
                mPresenter.operateToOptional(activity, item, position)
            } else {
                val stockName = item?.run { name } ?: ""
                UserActionReader.subMitUserAction(UserActionFunctionId.LIMIT_UP_UNLOCK_PERMISSION,
                        SkyUserAction.ParamItem("tab", "主力"),
                        SkyUserAction.ParamItem("stock", stockName),
                        SkyUserAction.ParamItem("field", "整行"))
                jumpToUnlockBuy()
            }
        }
        UserActionReader.subMitUserAction(LIMIT_UP_ADD_OPTIONAL)
    }

    override fun onTagCauseClick(model: LimitTopicModel?) {
        model?.let {
            val intent = Intent(activity, StockTagDetailActivity::class.java)
            intent.putExtra("topic", it.topic)
            intent.putExtra("topicId", it.tagId)
            startActivity(intent)
        }
        UserActionReader.subMitUserAction(UserActionFunctionId.LIMIT_UP_CLICK_CAUSE_TAG)
    }

    override fun onItemClick(position: Int) {
        val index = position - 1
        if (mPermission) {
            if (index >= 0 && index < mDataModels.size) {
                val isLandscape = context?.resources?.configuration?.orientation == Configuration.ORIENTATION_LANDSCAPE
                val intent = if (isLandscape) {
                    Intent(activity, SpeedDetailLandActivity::class.java)
                } else {
                    Intent(activity, SpeedDetailActivity::class.java)
                }
                intent.putExtra(F5Session.POSITION, index)
                F5Session.getInstance().f5WindCodes = mPresenter.getWindCodes(mDataModels)
                startActivity(intent)
            }
        } else {
            var stockName = ""
            if (index >= 0 && index < mDataModels.size) {
                stockName = mDataModels[index]?.run { name } ?: ""
            }
            UserActionReader.subMitUserAction(UserActionFunctionId.LIMIT_UP_UNLOCK_PERMISSION,
                    SkyUserAction.ParamItem("tab", "主力"),
                    SkyUserAction.ParamItem("stock", stockName),
                    SkyUserAction.ParamItem("field", "整行"))
            jumpToUnlockBuy()
        }
        UserActionReader.subMitUserAction(UserActionFunctionId.LIMIT_UP_STOCK_ITEM_CLICK)
    }

    override fun onItemLongClick(position: Int) {}
    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.limit_refresh_btn -> mPresenter.reqLimitDetail()
        }
        clickTip(v)
    }

    override fun touchEvent(sender: View?, event: MotionEvent?) {
        val tag = sender?.tag
        if (tag is LimitSort) {
            UserActionReader.subMitUserAction(UserActionFunctionId.LIMIT_UP_SORT,
                    SkyUserAction.ParamItem("tab", "快涨停"),
                    SkyUserAction.ParamItem("field", tag.value))
            resetSortTextExcludeId(tag)
            val sortType = (sender as? SortTextViewEx)?.status ?: 0
            val fieldId = if (sortType == 0) SORT_DEFAULT_ID else tag.sortId
            mPresenter.reqLimitDetailBySort(fieldId, sortType, mDataModels)
        }
    }

    /**
     * 除了当前点击的sortText，其他还原排序状态
     *
     * @param sort 当前点击的sortText id
     */
    private fun resetSortTextExcludeId(sort: LimitSort) {
        for (item in mSortTextViewList) {
            if (item.tag != sort && item.status != 0) {
                item.clearIcon()
            }
        }
    }

    override fun onLoadMore() {}
    override fun onRefresh() {
        mPresenter.reqLimitDetailByPullRefresh()
    }

    override fun onLimitPermissionBuy() {
        mPresenter.reqLimitDetail()
    }

    companion object ConstField {
        private const val ERROR_MSG = 1
        private const val RESULT_MSG = 2
        private const val UPDATE_LIST_PART_MSG = 3
        private const val UPDATE_LIST_OPEN_TIP = 4
        private const val SHOW_TIP_MSG = 5
        private const val UPDATE_LIST_TITLE = 6
        private const val RESET_LIST_TITLE = 7
    }

    override fun onLastDate(isLast: Boolean) {
        if (this::mAdapter.isInitialized) {
            mAdapter.setLastDate(isLast)
        }
        if (this::mRightGroup.isInitialized) {
            for (index in 0 until mRightGroup.childCount) {
                val child = mRightGroup.getChildAt(index)
                val tag = child.tag
                if (tag is LimitSort) {
                    if (SORT_TODAY_CHANGE == tag.index || SORT_UP_TO_CHANGE == tag.index) {
                        child.visibility = if (isLast) View.GONE else View.VISIBLE
                    }
                }
            }
        }
    }

    override fun onInitParamsReceive(date: String, isFilterOptional: Boolean, filterIds: MutableList<Int>?, topicIds: MutableList<Int>?) {mPresenter.setFilterOptional(isFilterOptional)
        if (mFragVisible) {
            mPresenter.setFilterOptional(isFilterOptional)
            mPresenter.reqLimitDetail(date, filterIds, topicIds)
        }
    }
}