package wind.android.bussiness.strategy.limitupseizeup.presenter

import wind.android.bussiness.strategy.limitupseizeup.view.BaseLimitView
import wind.android.f5.level2.manager.LittleTrendManager
import wind.android.f5.model.LittleTrendModel
import java.lang.ref.WeakReference

/**
 * # **********************************************************************************************
 * # ClassName:      BaseLimitPresenter
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/9/27    17:03
 * # Modifications:  initial
 * # **********************************************************************************************
 */

open class BaseLimitPresenter<T : BaseLimitView>(view: T) : LittleTrendManager.LittleTrendRefreshListener {
    protected val mView = WeakReference<T>(view)

    private lateinit var mLittleTrendManager: LittleTrendManager

    protected fun getView(): T? {
        return mView.get()
    }

    fun detachView() {
        mView.clear()
    }

    fun initLittleTrendManager(todayDate: Int) {
        mLittleTrendManager = LittleTrendManager(todayDate)
        mLittleTrendManager.setLittleTrendRefreshListener(this)
    }

    fun subTrend(windCode: String) {
        if (this::mLittleTrendManager.isInitialized) {
            mLittleTrendManager.subTrend(windCode)
        }
    }

    override fun onRefresh(model: LittleTrendModel?) {

    }
}