package wind.android.bussiness.strategy.limitupseizeup.view

import android.content.Context
import android.graphics.Canvas
import android.graphics.Paint
import android.os.Build
import android.util.AttributeSet
import android.widget.TextView
import util.StringUtils

/**
 * # **********************************************************************************************
 * # ClassName:      HalfCircleTextView
 * # Description:    半圆背景的TextView
 * # Author:         ylrong
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    ylrong     2020/1/2    10:18
 * # Modifications:  initial
 * # **********************************************************************************************
 */
class HalfCircleTextView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0)
    : TextView(context, attrs, defStyleAttr) {

    private lateinit var mBgPaint: Paint

    override fun onDraw(canvas: Canvas?) {
        if (!this::mBgPaint.isInitialized) {
            mBgPaint = Paint()
            mBgPaint.style = Paint.Style.STROKE
            mBgPaint.strokeWidth = StringUtils.dipToPx(1f).toFloat()
            mBgPaint.isAntiAlias = true
        }
        mBgPaint.color = currentTextColor

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            canvas?.drawRoundRect(-width.toFloat(), 0f, width.toFloat() - 1f, height.toFloat() - 1f, height.toFloat() / 2, height.toFloat() / 2, mBgPaint)
        } else {
            canvas?.drawRect(-width.toFloat(), 0f, width.toFloat() - 1f, height.toFloat() - 1f, mBgPaint)

        }
        super.onDraw(canvas)
    }
}