package wind.android.bussiness.strategy.limitupseizeup.view

import android.support.annotation.IntDef
import wind.android.bussiness.strategy.limitupseizeup.bean.LimitUpDetailModel
import wind.android.f5.model.LittleTrendModel

/**
 * # **********************************************************************************************
 * # ClassName:      ILimitFragView
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/7/16    16:24
 * # Modifications:  initial
 * # **********************************************************************************************
 */

interface ILimitFragView : BaseLimitView {

    @IntDef(ADD_OPT_STOCK, DEL_OPT_STOCK)
    annotation class UpdateType

    /**
     * 更新列表
     *
     * @param list 列表数据源
     */
    fun onUpdateListAll(list: MutableList<LimitUpDetailModel?>?)

    /**
     * 局部刷新列表
     *
     * @param position item position
     */
    fun onUpdateListByPosition(position: Int, @UpdateType type: Int)
    /**
     * 局部刷新列表
     *
     * @param model 走势图
     */
    fun onUpdateLittleTrend(model: LittleTrendModel?)

    /**
     * 更新涨停捉妖权限
     *
     * @param isPermission
     */
    fun onUpdatePermission(isPermission: Boolean)

    /**
     * 错误信息
     */
    fun onError(errorType: Int, errorMsg: String?)

    /**
     * 提示信息
     */
    fun onShowTip(tip: String?)

    /**
     * 展示进度条
     */
    fun onShowProgressMum()
    /**
     * 隐藏进度条
     */
    fun onHideProgressMum()


    companion object ConstField {
        /**
         * 添加自选股
         */
        const val ADD_OPT_STOCK = 1
        /**
         * 删除自选股
         */
        const val DEL_OPT_STOCK = 2
    }
}
