package wind.android.bussiness.strategy.limitupseizeup.view

import android.content.Context
import android.support.design.R
import android.support.design.widget.TabLayout
import android.util.AttributeSet
import android.view.ViewGroup
import ui.screen.UIScreen

/**
 * # **********************************************************************************************
 * # ClassName:      TitleTabLayout1
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/10/17    10:05
 * # Modifications:  initial
 * # **********************************************************************************************
 */

class TitleTabLayout @JvmOverloads constructor(
        context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = R.attr.tabStyle
) : TabLayout(context, attrs, defStyleAttr) {
    init {
        setSelectedTabIndicatorHeight(0)
    }
    /**
     * 设置标题栏添加标题
     *
     * @param titles 标题数组
     * @param tabWidth 标题tab宽度
     */
    @JvmOverloads
    fun setTabItems(titles: Array<String>, tabWidth: Int = 0, tabTitleTextSize: Int = 17) {
        removeAllTabs()
        val tabItemWidth = if (tabWidth == 0) UIScreen.screenWidth / titles.size else tabWidth
        val tabItemLp = MarginLayoutParams(tabItemWidth, ViewGroup.LayoutParams.MATCH_PARENT)
        for (i in titles.indices) {
            val tab = newTab()
            val titleView = TitleMsgView(context)
            titleView.layoutParams = tabItemLp
            titleView.setMsgTextVisible(false)
            titleView.setTitleText(titles[i])
            titleView.setTitleTextSize(tabTitleTextSize)
            tab.customView = titleView
            addTab(tab, i, false)
        }
    }

    /**
     * 设置标题右上角消息数字，如果为0，则隐藏
     *
     * @param index tab position
     * @param count 显示的数目
     */
    fun setTabMsgCount(index: Int, count: Int) {
        val titleView: TitleMsgView? = getTabAt(index)?.customView as? TitleMsgView
        titleView?.setMsgTextVisible(count != 0)
        titleView?.setMsgText(count.toString())
    }

    /**
     * 设置选中的tab
     *
     * @param index 选中tab index
     */
    fun setSelectTab(index: Int) {
        getTabAt(index)?.select()
    }
}