package wind.android.bussiness.trade.abstocktrade

import android.support.annotation.IntDef
import cn.com.hh.trade.data.NSDPROCAPI

/**
 * # **********************************************************************************************
 * # ClassName:      AbStockConst
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/11/22    16:04
 * # Modifications:  initial
 * # **********************************************************************************************
 */

const val NON_GGT_TYPE = -1

@IntDef(NON_GGT_TYPE, NSDPROCAPI.GGT_STOCK, NSDPROCAPI.HGT_STOCK, NSDPROCAPI.SGT_STOCK)
annotation class GggType

const val GGT_TYPE_KEY = "ggt_type_key"

const val INT_FORMAT = "###,###,###"
const val DOUBLE_FORMAT = "###,###,##0.00"

enum class TradeDelegateType(val value: Byte, val delegateName: String) {
    /**
     * "限价委托" to 0,
     * "对方最优价格" to 1,
     * "本方最优价格" to 2,
     * "即时成交剩余撤销" to 3,
     * "五档即成剩撤" to 4,
     * "全额成交或撤销" to 5,
     * "五档即成转限价" to 6
     * "盘后固定价格委托" to *  (科创板)
     */
    LIMIT_ORDER(0.toByte(), "限价委托"),
    BEST_PRICE_TO_OTHER(1.toByte(), "对方最优价格"),
    BEST_PRICE_TO_SELF(2.toByte(), "本方最优价格"),
    DEAL_IMMEDIATELY_SURPLUS_CANCEL(3.toByte(), "即时成交剩余撤销"),
    FIVE_IMMEDIATELY_SURPLUS_CANCEL(4.toByte(), "五档即成剩撤"),
    ALL_DEAL_OR_CANCEL(5.toByte(), "全额成交或撤销"),
    FIVE_IMMEDIATELY_SURPLUS_LIMIT_ORDER(6.toByte(), "五档即成转限价"),
    STIB_TYPE('*'.toByte(), "盘后固定价格委托")
}

enum class TradeDelegateDataType {
    DELEGATE_TYPE_DEF, DELEGATE_TYPE_SH, DELEGATE_TYPE_SZ,
    DELEGATE_TYPE_STIB, DELEGATE_TYPE_STIB_RZRQ
}

enum class TradeWindCodeType {
    /**
     * A股,科创板，国债，债券
     */
    A_STOCK, STIB_CODE, GOVERNMENT_BOND_SH, GOVERNMENT_BOND_SZ, BOND
}