package wind.android.bussiness.trade.abstocktrade.adapter

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import wind.android.R
import wind.android.bussiness.optionalstock.model.SearchRecord

/**
 * # **********************************************************************************************
 * # ClassName:      TradeSearchAdapter
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/11/26    19:09
 * # Modifications:  initial
 * # **********************************************************************************************
 */

class TradeSearchAdapter(private val context: Context) : RecyclerView.Adapter<RecyclerView.ViewHolder>() {
    /**
     * 数据源
     */
    val data: ArrayList<SearchRecord?> by lazy { ArrayList<SearchRecord?>() }

    /**
     * 设置数据源并刷新页面
     *
     * @param list
     */
    fun setData(list: List<SearchRecord?>?) {
        data.clear()
        list?.let { data.addAll(it) }
        notifyDataSetChanged()
    }

    var onItemClickListener: ((Int) -> Unit)? = null

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): RecyclerView.ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.trade_search_list_item, p0, false)
        return SearchViewHolder(view, onItemClickListener)
    }

    override fun getItemCount(): Int {
        return data.size
    }

    override fun onBindViewHolder(p0: RecyclerView.ViewHolder, p1: Int) {
        val viewHolder = p0 as SearchViewHolder
        val item = if (p1 < data.size) data[p1] else null
        item?.apply {
            viewHolder.stockCode.text = windcode
            viewHolder.stockName.text = stockname
            viewHolder.itemView.tag = p1
        }
    }

    private class SearchViewHolder(itemView: View, itemClickListener: ((Int) -> Unit)?) : RecyclerView.ViewHolder(itemView) {
        val stockCode: TextView by lazy { itemView.findViewById<TextView>(R.id.stock_code) }
        val stockName: TextView by lazy { itemView.findViewById<TextView>(R.id.stock_name) }

        init {
            itemView.setOnClickListener { itemClickListener?.invoke(it.tag as Int) }
        }
    }
}