package wind.android.bussiness.trade.abstocktrade.bean

import base.data.IData
import wind.android.bussiness.trade.abstocktrade.TradeDelegateDataType
import wind.android.bussiness.trade.abstocktrade.TradeDelegateType
import wind.android.bussiness.trade.abstocktrade.TradeWindCodeType

/**
 * # **********************************************************************************************
 * # ClassName:      AbTradeBusinessModel
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/12/2    11:20
 * # Modifications:  initial
 * # **********************************************************************************************
 */

data class AbTradeBusinessModel(var windCode: String? = null, var stockCode: String? = null,
                                var stockName: String? = null, var currentPrice: Double = 0.00,
                                var highLimitPrice: Float = -1.00f, var lowLimitPrice: Float = -1.00f,
                                var maxVolume: Int = 0, var maxVolumeUnit: String? = null,
                                var delegateType: TradeDelegateType = TradeDelegateType.LIMIT_ORDER,
                                var orderPrice: Double = 0.00, var orderAmount: Int = 0,
                                var lotSize: Int = 100, var pricePrecision: Int = 2,
                                var windCodeType: TradeWindCodeType = TradeWindCodeType.A_STOCK,
                                var priceChangeable: Boolean = true,
                                var delegateDataType: TradeDelegateDataType = TradeDelegateDataType.DELEGATE_TYPE_DEF) : IData {
    fun resetFieldValue() {
        windCode = null
        stockCode = null
        stockName = null
        currentPrice = 0.00
        highLimitPrice = -1.00f
        lowLimitPrice = -1.00f
        maxVolume = 0
        maxVolumeUnit = null
        delegateType = TradeDelegateType.LIMIT_ORDER
        orderPrice = 0.00
        orderAmount = 0
        lotSize = 100
        pricePrecision = 2
        windCodeType = TradeWindCodeType.A_STOCK
        priceChangeable = true
        delegateDataType = TradeDelegateDataType.DELEGATE_TYPE_DEF
    }
}