package wind.android.bussiness.trade.abstocktrade.fragment

import android.content.Intent
import android.os.Message
import android.text.SpannableString
import android.view.Gravity
import android.view.LayoutInflater
import android.view.MotionEvent
import android.view.View
import android.widget.CompoundButton
import base.BaseNetHandler.NetStatusListener
import eventbus.EventBusManager
import kotlinextend.addTextWatcher
import kotlinextend.viewGone
import kotlinx.android.synthetic.main.a_stock_buy_head.*
import kotlinx.android.synthetic.main.ab_buy_select_view.*
import kotlinx.android.synthetic.main.frag_a_stock_buy.*
import net.datamodel.network.RealQuoteItem
import net.datamodel.speed.BidTrendData
import net.datamodel.speed.NewTrendData
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import util.ThemeUtils
import util.ToastTool
import wind.android.R
import wind.android.bussiness.trade.abstocktrade.adapter.AStockBuyAdapter
import wind.android.bussiness.trade.abstocktrade.addThousandth
import wind.android.bussiness.trade.abstocktrade.eventbus.StockTradeMsgEvent
import wind.android.bussiness.trade.abstocktrade.eventbus.StockTradeMsgEvent.USERCODE_FRAGMENT_ACTIVITY
import wind.android.bussiness.trade.abstocktrade.eventbus.UserCodeMsgEvent
import wind.android.bussiness.trade.abstocktrade.presenter.AStockBuySellPresenter
import wind.android.bussiness.trade.abstocktrade.presenter.AStockBuySellPresenter.Companion.ADVANCE_DELEGATE_TIP_TYPE1
import wind.android.bussiness.trade.abstocktrade.presenter.AStockBuySellPresenter.Companion.BUY
import wind.android.bussiness.trade.abstocktrade.presenter.AStockBuySellPresenter.Companion.PLACEHOLDER_MAX_VOLUME
import wind.android.bussiness.trade.abstocktrade.presenter.AStockBuySellPresenter.Companion.TIP_ALERT
import wind.android.bussiness.trade.abstocktrade.presenter.AStockBuySellPresenter.Companion.TIP_TOAST
import wind.android.bussiness.trade.abstocktrade.view.IAStockBuySellView
import wind.android.bussiness.trade.abstocktrade.view.TradeSearchDialog
import wind.android.bussiness.trade.activity.ProtocolActivity
import wind.android.bussiness.trade.activity.TradeBusiness5lView
import wind.android.bussiness.trade.constant.TradeConstantData
import wind.android.bussiness.trade.constant.TradeUserAction
import wind.android.bussiness.trade.home.model.JSHoldStockValue
import wind.android.bussiness.trade.model.Trade5LModel
import wind.android.bussiness.trade.model.TradeJumpConstants
import wind.android.bussiness.trade.view.ActionSheetDialog
import wind.android.bussiness.trade.view.TradeBottomDialog
import wind.android.bussiness.trade.windtip.WindIPODialog

/**
 * # **********************************************************************************************
 * # ClassName:      AStockBuyFrag
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/11/18    16:48
 * # Modifications:  initial
 * # **********************************************************************************************
 */

open class AStockBuyFrag : BaseATradeFrag<IAStockBuySellView, AStockBuySellPresenter>(), IAStockBuySellView,
        View.OnClickListener, CompoundButton.OnCheckedChangeListener, TradeBusiness5lView.TradeBS5lListener {

    private val adapter by lazy { AStockBuyAdapter(activity!!) }

    private var windCode: String? = null
    /**
     * 需要刷新
     */
    private var needRefresh: Boolean = false
    /**
     * 交易弹框
     */
    private val tradeBottomDialog by lazy { TradeBottomDialog() }

    override fun getLayoutId(): Int {
        return R.layout.frag_a_stock_buy
    }

    override fun isRegisterEventBus(): Boolean {
        return true
    }

    override fun init() {
        val headView = LayoutInflater.from(activity!!).inflate(R.layout.a_stock_buy_head, null)
        list_view.addHeaderView(headView)
        list_view.adapter = adapter
        code_name_layout.setOnClickListener(this)
        strategy_layout.setOnClickListener(this)
        minus_price.setOnClickListener(this)
        val layoutBgResId = ThemeUtils.getResId(R.drawable.a_stock_buy_edit_bg_selector_b,
                R.drawable.a_stock_buy_edit_bg_selector_w)
        strategy_layout.setBackgroundResource(layoutBgResId)
        price_layout.setBackgroundResource(layoutBgResId)
        price_edit.addTextWatcher {
            afterTextChangedFun {
                if (!it.isNullOrEmpty() && it.isNotBlank()) {
                    val priceValue = try {
                        it.toString().trim().toDouble()
                    } catch (e: Exception) {
                        0.00
                    }
                    presenter.setNewOrderPrice(priceValue, updateView = false)
                } else {
                    presenter.setBlankPrice()
                }
            }
        }
        add_price.setOnClickListener(this)
        lowest_price_title.setOnClickListener(this)
        lowest_price_value.setOnClickListener(this)
        max_buy_title.setOnClickListener(this)
        max_buy_value.setOnClickListener(this)
        highest_price_title.setOnClickListener(this)
        highest_price_value.setOnClickListener(this)
        minus_amount.setOnClickListener(this)
        amount_edit.addTextWatcher {
            afterTextChangedFun {
                it?.let { presenter.setAmount(it.toString()) }
            }
        }
        add_amount.setOnClickListener(this)
        all_hold.setOnCheckedChangeListener(this)
        half_hold.setOnCheckedChangeListener(this)
        one_third_hold.setOnCheckedChangeListener(this)
        quarter_hold.setOnCheckedChangeListener(this)
        trade_operate_btn.setOnClickListener(this)
        five_view.bs5Listener = this
        five_view.bindView(list_view)
        list_view.setOnItemClickListener { _, _, position, _ ->
            val item = adapter.getItem(position - 1)
            item?.run {
                presenter.setWindCodeInfo(windCode, stockName, chUserCode)
                list_view.setSelection(0)
            }
        }
        windCode = arguments?.getString(TradeJumpConstants.KEY_WINDCODE)
        presenter.setWindCodeInfo(windCode, null)
    }

    override fun onFragHide(byOnPause: Boolean) {
        five_view.unSub()
        trend_view.onPause()
        presenter.unregisterListener()
    }

    override fun onFragShow(byOnResume: Boolean) {
        presenter.registerListener()
        presenter.reqHoldListData(ggType)
        windCode?.let { five_view.sub(it) }
        trend_view.onResume()
        if (!byOnResume && needRefresh) {
            EventBusManager.getInstance().post(StockTradeMsgEvent(
                    USERCODE_FRAGMENT_ACTIVITY, null, windCode))
            needRefresh = false
        }
    }

    override fun createPresenter(): AStockBuySellPresenter {
        return AStockBuySellPresenter(this, BUY)
    }

    override fun onUpdateHoldList(holdList: List<JSHoldStockValue>?) {
        val msg = Message.obtain()
        msg.what = MSG_UPDATE_HOLD_LIST
        msg.obj = holdList
        sendMessage(msg)
    }

    override fun onUpdateCodeName(windCode: String, code: String, name: String) {
        this.windCode = windCode
        trend_view.windCode = windCode
        five_view.sub(windCode)
        stock_code.text = code
        stock_name.text = name
        code_name_hint.viewGone()
        resetRadioBtnState()
    }

    override fun onUpdateDelegateType(type: String, hint: String, clickable: Boolean, isClearPrice: Boolean, isChangeable: Boolean) {
        trade_strategy.text = type
        strategy_layout.isEnabled = isChangeable
        price_edit.isEnabled = clickable
        price_layout.isEnabled = clickable
        price_edit.hint = hint
        if (isClearPrice) {
            price_edit.setText("")
        }
    }

    override fun onUpdateOrderPrice(priceValue: String) {
        price_edit.setText(priceValue)
    }

    override fun onUpdateMaxVolume(maxValue: Int, unit: String?) {
        val message = Message.obtain()
        message.what = MSG_UPDATE_MAX_VOLUME
        message.arg1 = maxValue
        message.obj = unit
        sendMessage(message)
    }

    override fun onUpdateLowLimitPrice(lowPrice: String) {
        lowest_price_value.text = lowPrice
    }

    override fun onUpdateHighLimitPrice(highPrice: String) {
        highest_price_value.text = highPrice
    }

    override fun onUpdateOrderAmount(amount: String) {
        amount_edit.setText(amount)
    }

    override fun onShowTradeConfirm(title: String, tip: String, name: String, value: String) {
        showAlert4Trade(title, tip, name, value, true) {
            presenter.bsDelegate()
        }
    }

    override fun onTradeResult(success: Boolean, msg: String) {
        val message = Message.obtain()
        message.what = MSG_TRADE_RESULT
        message.arg1 = if (success) 1 else -1
        message.obj = msg
        sendMessage(message)
    }

    override fun onShowAdvanceDelegate(type: Int, tipString: SpannableString) {
        val message = Message.obtain()
        message.what = MSG_SHOW_ADVANCE_TRUST
        message.arg1 = type
        message.obj = tipString
        sendMessage(message)
    }

    override fun showLoading() {
        showProgressMum()
    }

    override fun hideLoading() {
        hideProgressMum()
    }

    override fun errorMsg(errorType: Int, msg: String?) {
        val message = Message.obtain()
        message.what = MSG_ERROR
        message.arg1 = errorType
        message.obj = msg
        sendMessage(message)
    }

    override fun handleMessage(msg: Message?) {
        super.handleMessage(msg)
        when (msg?.what) {
            MSG_UPDATE_HOLD_LIST -> {
                val list = msg.obj as? List<JSHoldStockValue>?
                adapter.setData(list)
                if (windCode.isNullOrEmpty()) {
                    val firstValue = list?.firstOrNull()
                    firstValue?.let {
                        presenter.setWindCodeInfo(it.windCode, it.stockName, it.chUserCode)
                    }
                }
            }
            MSG_UPDATE_MAX_VOLUME -> {
                val maxVolume = msg.arg1
                val valueStr = if (maxVolume != PLACEHOLDER_MAX_VOLUME) {
                    presenter.setMaxVolume(maxVolume)
                    maxVolume.addThousandth() + (msg.obj as? String ?: "")
                } else {
                    "--"
                }
                max_buy_value.text = valueStr

            }
            MSG_TRADE_RESULT -> {
                if (msg.arg1 == 1) {
                    showDialog("交易成功", msg.obj as String)
                    presenter.reqHoldListData()
                    presenter.queryMaxVolume()
                } else if (msg.arg1 == -1) {
                    showDialog(message = msg.obj as String)
                }
            }
            MSG_ERROR -> {
                val tipType = msg.arg1
                if (tipType == TIP_TOAST) {
                    ToastTool.showToast(msg.obj as String)
                } else if (tipType == TIP_ALERT) {
                    showDialog(message = msg.obj as String)
                }
            }
            MSG_SHOW_ADVANCE_TRUST -> {
                showAdvanceDelegateDialog(msg.arg1, msg.obj as SpannableString)
            }
        }
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            //搜索股票
            R.id.code_name_layout -> {
                val dialog = TradeSearchDialog(activity!!)
                dialog.onItemClickCallback = { windCode, stockName ->
                    presenter.setWindCodeInfo(windCode, stockName)
                }
                dialog.show()
            }
            //委托方式
            R.id.strategy_layout -> {
                showDelegateTypeSelector()
            }
            //价格-
            R.id.minus_price -> {
                TradeConstantData.submitUserActionEx(TradeUserAction.BUTTON_TRADE_REDUCE)
                presenter.minusPrice(price_edit.text.toString().trim())
            }
            //价格+
            R.id.add_price -> {
                TradeConstantData.submitUserActionEx(TradeUserAction.BUTTON_TRADE_ADD)
                presenter.addPrice(price_edit.text.toString().trim())
            }
            //跌停价设置为下单价
            R.id.lowest_price_title,
            R.id.lowest_price_value -> {
                presenter.setLowLimitPriceToOrder()
            }
            //最大可买量设置为下单数量
            R.id.max_buy_title,
            R.id.max_buy_value -> {
                presenter.setMaxAmountToOrder()
                resetRadioBtnState()
            }
            //涨停价设置为下单价
            R.id.highest_price_title,
            R.id.highest_price_value -> {
                presenter.setHighLimitPriceToOrder()
            }
            //数量-
            R.id.minus_amount -> {
                presenter.minusAmount(amount_edit.text.toString().trim())
                resetRadioBtnState()
            }
            //数量+
            R.id.add_amount -> {
                presenter.addAmount(amount_edit.text.toString().trim())
                resetRadioBtnState()
            }
            //买入
            R.id.trade_operate_btn -> presenter.bsDelegateOperate()
        }
    }

    override fun onCheckedChanged(buttonView: CompoundButton?, isChecked: Boolean) {
        when (buttonView?.id) {
            R.id.all_hold -> if (isChecked) presenter.calculateAmount(1.0)
            R.id.half_hold -> if (isChecked) presenter.calculateAmount(0.5)
            R.id.one_third_hold -> if (isChecked) presenter.calculateAmount(1 / 3.toDouble())
            R.id.quarter_hold -> if (isChecked) presenter.calculateAmount(0.25)
        }
    }

    private fun showDelegateTypeSelector() {
        val selectorDialog = ActionSheetDialog(activity!!)
                .builder()
                .setCancelable(true)
                .setCanceledOnTouchOutside(true)
        val delegateTypeData = presenter.getDelegateTypeData()
        delegateTypeData?.forEach { type ->
            selectorDialog.addSheetItem(type.delegateName, ActionSheetDialog.SheetItemColor.Blue) {
                presenter.delegateType = type
            }
        } ?: return
        selectorDialog.show()
    }

    private fun resetRadioBtnState() {
        if (all_hold.isChecked) {
            all_hold.isChecked = false
        }
        if (half_hold.isChecked) {
            half_hold.isChecked = false
        }
        if (one_third_hold.isChecked) {
            one_third_hold.isChecked = false
        }
        if (quarter_hold.isChecked) {
            quarter_hold.isChecked = false
        }
    }

    /**
     * 买卖五档/十档回调 setBs5Listener（this）
     */
    override fun onRowClick(text: String?, actionEvent: Int) {
        if (actionEvent == MotionEvent.ACTION_DOWN) {
            text?.let {
                if (presenter.priceChangeable()) {
                    price_edit.setText(it)
                }
            }
        }
    }

    /**
     * 买卖五档/十档回调 setBs5Listener（this）
     */
    override fun onNewTrendData(data: NewTrendData?) {
    }

    /**
     * 买卖五档/十档回调 setBs5Listener（this）
     */
    override fun onSubDataback(model: Trade5LModel?) {
    }

    /**
     * 买卖五档/十档回调 setBs5Listener（this）
     */
    override fun onMaskDataback(model: Trade5LModel?) {
        //已经在主线程
        model?.run {
            if (stock_code.text.toString().isNotEmpty() && stock_name.text.toString().isEmpty()
                    && this@AStockBuyFrag.windCode == windCode && !name.isNullOrEmpty()) {
                //解决外部传入windCode，没有stockName问题
                stock_name.text = name
                presenter.setStockName(name)
            }
            presenter.setStockPriceInfo(pricehighlimt, pricelowlimt, price)
        }
    }

    /**
     * 买卖五档/十档回调 setBs5Listener（this）
     */
    override fun onRealQuoteItem(type: Int, item: RealQuoteItem?) {
    }

    /**
     * 买卖五档/十档回调 setBs5Listener（this）
     */
    override fun setAfterMarket(data: BidTrendData?) {
    }

    /**
     * 买卖五档/十档回调 setBs5Listener（this）
     */
    override fun setAfterMarket(data: RealQuoteItem?) {
    }

    /**
     * 交易确认弹窗
     *
     * @param title
     * @param tip
     * @param name
     * @param value
     * @param isBuy
     * @param clickListener
     */
    protected fun showAlert4Trade(title: String?, tip: String?, name: String?, value: String?, isBuy: Boolean, clickListener: (view: View) -> Unit) {
        tradeBottomDialog.setValues(title, tip, name, value, isBuy)
                .setOnClickListener(clickListener)
        if (tradeBottomDialog.dialog?.isShowing == true) {
            tradeBottomDialog.dismiss()
        } else {
            tradeBottomDialog.show(childFragmentManager, "TradeBottomDialog")
        }
    }

    /**
     * 预约委托弹窗
     *
     * @param type
     * @param tips
     */
    private fun showAdvanceDelegateDialog(type: Int, tips: SpannableString) {
        if (activity == null) return
        val windTipDialog = WindIPODialog(activity, false).builder()
        if (type == ADVANCE_DELEGATE_TIP_TYPE1) {
            windTipDialog.setNegativeButton("取消", null).showProtocolView(View.VISIBLE)
        } else {
            windTipDialog.showProtocolView(View.GONE)
        }
        windTipDialog.setTitle("温馨提示").setPositiveButton("确认") {
            if (type == ADVANCE_DELEGATE_TIP_TYPE1) {
                presenter.advanceDelegate()
            }
        }.setCancelable(true).setSpandMsg(tips, Gravity.START)
                .setProtocolClickListener {
                    val intent = Intent(activity, ProtocolActivity::class.java)
                    intent.putExtra(ProtocolActivity.PROTOCOL_TITLE, "隔日证券预约委托业务约定书")
                    intent.putExtra(ProtocolActivity.PROTOCOL_CONTENT, "adventrust_protocol.doc")
                    startActivity(intent)
                }.show()
    }

    @Subscribe(threadMode = ThreadMode.MAIN, sticky = true)
    fun onUserCodeReceive(event: UserCodeMsgEvent) {
        if (presenter.userCode == event.userCode) {
            return
        }
        presenter.userCode = event.userCode
        if (fragVisible) {
            presenter.queryMaxVolume()
        } else {
            needRefresh = true
        }
    }

    override fun onSpeedStatusChange(status: Int, detailMsg: String?) {
        if (status == NetStatusListener.NET_CONNECTED && !windCode.isNullOrEmpty()) {
            five_view.sub(windCode)
            trend_view.onResume()
        }
    }

    companion object {
        const val MSG_UPDATE_HOLD_LIST = 0x1
        const val MSG_UPDATE_MAX_VOLUME = 0x2
        const val MSG_ERROR = 0x3
        const val MSG_TRADE_RESULT = 0x4
        const val MSG_SHOW_ADVANCE_TRUST = 0x5
    }
}