package wind.android.bussiness.trade.abstocktrade.fragment

import android.support.v4.content.res.ResourcesCompat
import kotlinx.android.synthetic.main.ab_buy_select_view.*
import util.CommonValue
import util.ThemeUtils
import wind.android.R
import wind.android.bussiness.trade.abstocktrade.presenter.AStockBuySellPresenter

/**
 * # **********************************************************************************************
 * # ClassName:      AStockSellFrag
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/11/18    16:58
 * # Modifications:  initial
 * # **********************************************************************************************
 */

class AStockSellFrag : AStockBuyFrag() {
    override fun createPresenter(): AStockBuySellPresenter {
        return AStockBuySellPresenter(this, AStockBuySellPresenter.SELL)
    }

    override fun init() {
        super.init()
        code_name_layout.setBackgroundResource(R.drawable.a_stock_sell_edit_bg)
        val layoutBgResId = ThemeUtils.getResId(R.drawable.a_stock_sell_edit_bg_selector_b,
                R.drawable.a_stock_sell_edit_bg_selector_w)
        strategy_layout.setBackgroundResource(layoutBgResId)
        price_layout.setBackgroundResource(layoutBgResId)
        add_price.setImageResource(R.drawable.plus_sign_green)
        minus_price.setImageResource(R.drawable.minus_sign_green)
        max_buy_title.text = "可卖"
        add_amount.setImageResource(R.drawable.plus_sign_green)
        minus_amount.setImageResource(R.drawable.minus_sign_green)
        amount_layout.setBackgroundResource(R.drawable.a_stock_sell_edit_bg)
        val radioTextColor = if (CommonValue.styleType == CommonValue.StyleType.STYLE_BLACK)
            ResourcesCompat.getColorStateList(resources, R.color.trade_sell_selector_color_b, null) else
            ResourcesCompat.getColorStateList(resources, R.color.trade_sell_selector_color_w, null)
        all_hold.setTextColor(radioTextColor)
        half_hold.setTextColor(radioTextColor)
        one_third_hold.setTextColor(radioTextColor)
        quarter_hold.setTextColor(radioTextColor)
        trade_operate_btn.setBackgroundResource(R.drawable.green_round_rect_selector)
        trade_operate_btn.text = "卖出"
    }

    override fun onShowTradeConfirm(title: String, tip: String, name: String, value: String) {
        showAlert4Trade(title, tip, name, value, false) {
            presenter.bsDelegate()
        }
    }
}