package wind.android.bussiness.trade.abstocktrade.presenter

import wind.android.bussiness.trade.abstocktrade.view.IBaseTradeView
import java.lang.ref.WeakReference

/**
 * # **********************************************************************************************
 * # ClassName:      BaseTradePresenter
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/11/19    11:05
 * # Modifications:  initial
 * # **********************************************************************************************
 */

open class BaseTradePresenter<V : IBaseTradeView>(view: V) {
    private var view: WeakReference<V>? = WeakReference(view)

    protected fun getView(): V? {
        return view?.get()
    }

    open fun detachView() {
        view?.clear()
        view = null
    }
}