package wind.android.bussiness.trade.abstocktrade.view

import android.text.SpannableString
import wind.android.bussiness.trade.home.model.JSHoldStockValue

/**
 * # **********************************************************************************************
 * # ClassName:      IAStockBuySellView
 * # Description:    WindStockDev
 * # Author:         wplin
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    wplin     2019/11/19    16:10
 * # Modifications:  initial
 * # **********************************************************************************************
 */

interface IAStockBuySellView : IBaseTradeView {
    /**
     * 更新持仓列表
     *
     * @param holdList
     */
    fun onUpdateHoldList(holdList: List<JSHoldStockValue>?)

    /**
     * 更新股票信息
     *
     * @param windCode
     * @param code
     * @param name
     */
    fun onUpdateCodeName(windCode: String, code: String, name: String)

    /**
     * 更新委托方式
     *
     * @param type
     * @param hint
     * @param clickable 价格是否可点击
     * @param isClearPrice 是否清空价格
     * @param isChangeable 委托方式是否可更改（债券类不可修改，且背景要置灰）
     */
    fun onUpdateDelegateType(type: String, hint: String, clickable: Boolean, isClearPrice: Boolean, isChangeable: Boolean = true)

    /**
     * 更新委托价格
     *
     * @param priceValue
     */
    fun onUpdateOrderPrice(priceValue: String)

    /**
     * 更新最大可买量
     *
     * @param maxValue
     */
    fun onUpdateMaxVolume(maxValue: Int, unit: String?)

    /**
     * 更新跌停价格
     *
     * @param lowPrice
     */
    fun onUpdateLowLimitPrice(lowPrice: String)

    /**
     * 更新涨停价
     *
     * @param highPrice
     */
    fun onUpdateHighLimitPrice(highPrice: String)

    /**
     * 更新委托数量
     *
     * @param amount
     */
    fun onUpdateOrderAmount(amount: String)

    /**
     * 交易确认信息
     *
     * @param title
     * @param tip
     * @param name
     * @param value
     */
    fun onShowTradeConfirm(title: String, tip: String, name: String, value: String)

    /**
     * 更新委托结果
     *
     * @param success
     * @param msg
     */
    fun onTradeResult(success: Boolean, msg: String)

    /**
     * 预约委托
     */
    fun onShowAdvanceDelegate(type: Int, tipString: SpannableString)
}