package wind.android.bussiness.trade.abstocktrade.view

import android.content.Context
import android.util.AttributeSet
import android.view.View
import cn.com.hh.trade.data.TagAns_Fun1026
import kotlinx.android.synthetic.main.view_today_transaction.view.*
import util.ToastTool
import wind.android.R
import wind.android.bussiness.trade.abstocktrade.adapter.AStockQueryTransactionAdapter
import wind.android.bussiness.trade.abstocktrade.manager.AbTradeManager
import wind.android.bussiness.trade.abstocktrade.manager.OnAbResultListener
import wind.android.bussiness.trade.abstocktrade.transferMode

/**
 * # **********************************************************************************************
 * # ClassName:      TodayTransactionView
 * # Description:    当日成交
 * # Author:         ylrong
 * # Version:        Ver 1.0
 * # **********************************************************************************************
 * # Modified By:    ylrong     2019/11/26    14:26
 * # Modifications:  initial
 * # **********************************************************************************************
 */
class TodayTransactionView @kotlin.jvm.JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0)
    : BaseAStockTradeView(context, attrs, defStyleAttr) {

    private val mAbTradeManager = AbTradeManager<Array<TagAns_Fun1026>>()

    private val mAdapter by lazy { AStockQueryTransactionAdapter(context) }

    private val mOnAbResultListener by lazy {
        object : OnAbResultListener<Array<TagAns_Fun1026>> {
            override fun onCallback(data: Array<TagAns_Fun1026>?) {
                val list = data?.let {
                    data.filter { it.nMadePrice != 0 }.map { transferMode(it) }
                }?.toTypedArray()
                post {
                    mAdapter.setData(list)
                    if (list.isNullOrEmpty()) {
                        tipInfo.visibility = VISIBLE
                    } else {
                        tipInfo.visibility = GONE
                    }
                }
            }

            override fun onError(error: Int, message: String?) {
                ToastTool.showToast(message)
            }
        }
    }

    override fun initView() {
        View.inflate(context, R.layout.view_today_transaction, this)
        listView.adapter = mAdapter
    }

    override fun show() {
        mAbTradeManager.registerListener(mOnAbResultListener)
        mAbTradeManager.queryTransaction(ggType)
    }

    override fun hide() {
        mAbTradeManager.unregisterListener(mOnAbResultListener)
    }

    override fun destroyView() {

    }
}
