package wind.android.f5.bussiness.investor.activity

import android.os.Bundle
import base.BaseActivity
import kotlinx.android.synthetic.main.activity_investor_qa_detail.*
import util.NewsTimeAssist
import util.ThemeUtils
import wind.android.f5.R
import wind.android.f5.bussiness.investor.model.InvestorQaModel

/**
 * # ***********************************************************************************************
 * # ClassName:      InvestorQaDetailActivity$
 * # Function:       投资者问答详情页面
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2020/2/12$    15:28$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class InvestorQaDetailActivity: BaseActivity() {

    companion object {
        const val DATA_TYPE_INVESTOR_QA_DATA = "DATA_TYPE_INVESTOR_QA_DATA"
    }

    private var mModel: InvestorQaModel? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        ThemeUtils.setTheme(this)
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_investor_qa_detail)
        hideNavigationBar(true)
        setStockStatusBarColor()
        initData()
        initView()
    }

    private fun initData() {
        mModel = intent.
                getParcelableExtra(DATA_TYPE_INVESTOR_QA_DATA) ?: null
    }

    private fun initView() {
        investor_qa_title.text = getTitleDate(mModel?._source?.getPublishDateValue())
        investor_qa_source.text = mModel?._source?.getFullSpellValue()
        investor_qa_date.text = getDetailTime(mModel?._source?.getPublishDateValue())
        investor_qa_question_content.text = mModel?._source?.getUnitValue()
        investor_qa_answer_content.text = mModel?._source?.getUnitInfoValue()
    }

    private fun getTitleDate(time: String?): String {
        if (time.isNullOrBlank()) {
            return "投资者问答"
        }
        return NewsTimeAssist.getInstance().getNewsTime4Show(time, "yyyy年MM月dd日") + "投资者问答"
    }

    private fun getDetailTime(time: String?): String {
        if (time.isNullOrBlank()) {
            return ""
        }
        return NewsTimeAssist.getInstance().getNewsTime4Show(time, "yyyy-MM-dd hh:mm")
    }
}