package wind.android.f5.view.bottom.subview.finance.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import base.BaseFragment
import base.BaseNetHandler
import wind.android.f5.view.bottom.subview.finance.adapter.FinanceDetailAdapter

/**
 * # ***********************************************************************************************
 * # ClassName:      AbsFinanceFragment$
 * # Function:       财务详情fragment基类
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/11/20$    16:59$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
abstract class AbsFinanceFragment : BaseFragment() {

    protected var mWindCode : String? = null

    private var mIsVisible = false

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)
        init()
        requestData()
    }

    fun setWindCode(windCode : String) {
        mWindCode = windCode
    }

    override fun onDestroyView() {
        super.onDestroyView()
        mIsVisible = false
    }

    override fun setUserVisibleHint(isVisibleToUser: Boolean) {
        super.setUserVisibleHint(isVisibleToUser)
        mIsVisible = userVisibleHint
    }

    override fun onResume() {
        super.onResume()
        BaseNetHandler.getInstance().addNetStatusListener(netStatusListener)
    }

    override fun onPause() {
        super.onPause()
        BaseNetHandler.getInstance().removeNetStatusListener(netStatusListener)
    }

    /**
     * 断网重连
     */
    private val netStatusListener = object : BaseNetHandler.NetStatusListener {
        override fun onSpeedStatusChange(status: Int, detailMsg: String?) {
        }

        override fun onSkyStatusChange(status: Int, detailMsg: String?) {
            if (status == BaseNetHandler.NetStatusListener.NET_CONNECTED) {
                // 断网重连
                requestData()
            }
        }

        override fun onSkyLoginResp(respCode: Int) {
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(getLayoutId(), null)
    }

    /**
     * 布局文件
     */
    abstract fun getLayoutId(): Int

    /**
     * 初始化
     */
    abstract fun init()

    /**
     * 请求数据
     */
    abstract fun requestData()

    /**
     * 横竖屏切换
     */
    abstract fun screenChange(intCurrentOrientation: Int)

}