package wind.android.f5.view.bottom.subview.finance.fragment

import android.content.pm.ActivityInfo
import android.content.res.Configuration
import android.view.View
import kotlinx.android.synthetic.main.fragment_finance_cash.*
import wind.android.f5.R
import wind.android.f5.view.bottom.subview.finance.listener.IShowChangeListener
import wind.android.f5.view.bottom.subview.finance.view.AbsFinanceView

/**
 * # ***********************************************************************************************
 * # ClassName:      FinanceProfitFragment$
 * # Function:       现金流量表
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/11/20$    17:51$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class FinanceCashFragment : AbsFinanceFragment(), IShowChangeListener {

    override fun getLayoutId(): Int {
        return R.layout.fragment_finance_cash
    }

    override fun init() {
        finance_cash_report_view.setWindCode(mWindCode ?: "")
        finance_cash_report_view.createPresenter(AbsFinanceView.PRESENTER_TYPE_CASH)
        finance_cash_report_view.showListener = this
        finance_cash_season_view.setWindCode(mWindCode ?: "")
        finance_cash_season_view.createPresenter(AbsFinanceView.PRESENTER_TYPE_CASH)
        finance_cash_season_view.showListener = this
        cash_tips_landscape.setOnClickListener {
            val orientation = resources.configuration.orientation
            if (orientation == Configuration.ORIENTATION_PORTRAIT) {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE
            } else {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
            }
        }
    }

    override fun requestData() {
        if (finance_cash_report_view.visibility == View.VISIBLE) {
            requestReport()
        } else {
            requestSeason()
        }
    }

    override fun screenChange(intCurrentOrientation: Int) {
        if (intCurrentOrientation == Configuration.ORIENTATION_PORTRAIT) {
            cash_tips_landscape.visibility = View.VISIBLE
            navigationBar?.setBackVisiable()
        } else if (intCurrentOrientation == Configuration.ORIENTATION_LANDSCAPE) {
            cash_tips_landscape.visibility = View.GONE
            navigationBar?.setBackHidden()
        }
    }

    private fun requestReport() {
        finance_cash_report_view.requestData()
    }

    private fun requestSeason() {
        finance_cash_season_view.requestData()
    }

    override fun showReport() {
        finance_cash_report_view.visibility = View.VISIBLE
        finance_cash_season_view.visibility = View.GONE
        requestReport()
    }

    override fun showSeason() {
        finance_cash_report_view.visibility = View.GONE
        finance_cash_season_view.visibility = View.VISIBLE
        requestSeason()
    }
}