package wind.android.f5.view.bottom.subview.finance.fragment

import android.content.pm.ActivityInfo
import android.content.res.Configuration
import android.view.View
import kotlinx.android.synthetic.main.fragment_finance_balance_sheet.*
import wind.android.f5.R
import wind.android.f5.view.bottom.subview.finance.view.AbsFinanceView

/**
 * # ***********************************************************************************************
 * # ClassName:      FinanceHKARDBalanceSheetFragment
 * # Function:       港美股ARD资产负债表
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/11/20$    17:51$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class FinanceHKARDBalanceSheetFragment : AbsFinanceFragment() {

    override fun getLayoutId(): Int {
        return R.layout.fragment_finance_balance_sheet
    }

    override fun init() {
        finance_balance_sheet_report_view.createPresenter(AbsFinanceView.PRESENTER_HK_ARD_TYPE_BALANCE_SHEET)
        finance_balance_sheet_report_view.setWindCode(mWindCode ?: "")
        finance_balance_sheet_report_view.setShowCompare(false)
        finance_balance_sheet_report_view.setDownBtnVisibility(View.GONE)
        balance_sheet_tips_landscape.setOnClickListener {
            val orientation = resources.configuration.orientation
            if (orientation == Configuration.ORIENTATION_PORTRAIT) {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE
            } else {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
            }
        }
    }

    override fun requestData() {
        finance_balance_sheet_report_view.requestData()
    }

    override fun screenChange(intCurrentOrientation: Int) {
        if (intCurrentOrientation == Configuration.ORIENTATION_PORTRAIT) {
            balance_sheet_tips_landscape.visibility = View.VISIBLE
            navigationBar?.setBackVisiable()
        } else if (intCurrentOrientation == Configuration.ORIENTATION_LANDSCAPE) {
            balance_sheet_tips_landscape.visibility = View.GONE
            navigationBar?.setBackHidden()
        }
    }

}