package wind.android.f5.view.bottom.subview.finance.fragment

import android.content.pm.ActivityInfo
import android.content.res.Configuration
import android.view.View
import kotlinx.android.synthetic.main.fragment_finance_cash.*
import wind.android.f5.R
import wind.android.f5.view.bottom.subview.finance.view.AbsFinanceView

/**
 * # ***********************************************************************************************
 * # ClassName:      FinanceHKARDCashFragment
 * # Function:       港美股ARD现金流量表
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/11/20$    17:51$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class FinanceHKARDCashFragment : AbsFinanceFragment() {

    override fun getLayoutId(): Int {
        return R.layout.fragment_finance_cash
    }

    override fun init() {
        finance_cash_report_view.setWindCode(mWindCode ?: "")
        finance_cash_report_view.setShowCompare(false)
        finance_cash_report_view.setDownBtnVisibility(View.GONE)
        finance_cash_report_view.createPresenter(AbsFinanceView.PRESENTER_HK_ARD_TYPE_CASH)
        cash_tips_landscape.setOnClickListener {
            val orientation = resources.configuration.orientation
            if (orientation == Configuration.ORIENTATION_PORTRAIT) {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE
            } else {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
            }
        }
    }

    override fun requestData() {
        finance_cash_report_view.requestData()
    }

    override fun screenChange(intCurrentOrientation: Int) {
        if (intCurrentOrientation == Configuration.ORIENTATION_PORTRAIT) {
            cash_tips_landscape.visibility = View.VISIBLE
            navigationBar?.setBackVisiable()
        } else if (intCurrentOrientation == Configuration.ORIENTATION_LANDSCAPE) {
            cash_tips_landscape.visibility = View.GONE
            navigationBar?.setBackHidden()
        }
    }

}