package wind.android.f5.view.bottom.subview.finance.fragment

import android.content.pm.ActivityInfo
import android.content.res.Configuration
import android.view.View
import kotlinx.android.synthetic.main.fragment_finance_key_index.*
import wind.android.f5.R
import wind.android.f5.view.bottom.subview.finance.listener.IShowChangeListener
import wind.android.f5.view.bottom.subview.finance.view.AbsFinanceView

/**
 * # ***********************************************************************************************
 * # ClassName:      FinanceHKKeyIndexFragment
 * # Function:       港美股关键指标
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/11/20$    17:51$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class FinanceHKKeyIndexFragment : AbsFinanceFragment(), IShowChangeListener {

    override fun getLayoutId(): Int {
        return R.layout.fragment_finance_key_index
    }

    override fun init() {
        finance_key_index_report_view.createPresenter(AbsFinanceView.PRESENTER_HK_TYPE_KEY_INDEX)
        finance_key_index_report_view.setWindCode(mWindCode ?: "")
        finance_key_index_report_view.showListener = this
        key_index_tips_landscape.setOnClickListener {
            val orientation = resources.configuration.orientation
            if (orientation == Configuration.ORIENTATION_PORTRAIT) {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE
            } else {
                activity?.requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
            }
        }
    }

    override fun requestData() {
        finance_key_index_report_view.requestDesc()
        finance_key_index_report_view.requestData()
    }

    override fun screenChange(intCurrentOrientation: Int) {
        if (intCurrentOrientation == Configuration.ORIENTATION_PORTRAIT) {
            key_index_tips_landscape.visibility = View.VISIBLE
            navigationBar?.setBackVisiable()
        } else if (intCurrentOrientation == Configuration.ORIENTATION_LANDSCAPE) {
            key_index_tips_landscape.visibility = View.GONE
            navigationBar?.setBackHidden()
        }
    }

    override fun showReport() {
    }

    override fun showSeason() {
    }
}