package wind.android.f5.view.bottom.subview.finance.view

import android.content.Context
import android.util.AttributeSet
import android.view.View
import android.view.ViewGroup
import ui.UIFixedScrollListView

/**
 * # ***********************************************************************************************
 * # ClassName:      FinanceScrollListView$
 * # Function:       财务详情-列表视图
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/11/25$    18:46$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class FinanceScrollListView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null)
    : UIFixedScrollListView(context, attrs) {

    private var mScrollId : Int = 0

    fun setScrollId(id : Int) {
        mScrollId = id
    }

    /**
     * 可滑动视图
     */
    override fun getScrollView(index: Int): View? {
        if (mScrollId == 0) {
            return null
        }
        val childAt = getChildAt(index) ?: null ?: return null
        val view = childAt as? ViewGroup
        return view?.findViewById(mScrollId)
    }

    /**
     * 最大滑动宽度
     */
    override fun getMaxScrollWidth() {
        if (maxScrollWidth != 0) return
        if (titleView is ViewGroup) {
            val titleGroup = titleView as ViewGroup
            val size = titleGroup.childCount
            for (i in 0 until size) {
                val tempView = titleGroup.getChildAt(i) ?: null
                if (tempView?.visibility == View.VISIBLE) {
                    maxScrollWidth += tempView.measuredWidth
                }
            }
            maxScrollWidth -= titleGroup.width
        }
    }
}
