package wind.android.f5.view.bottom.subview.finance.view

import wind.android.f5.view.bottom.subview.finance.model.FinanceF9ReportModel
import wind.android.f5.view.bottom.subview.finance.model.FinanceF9SeasonModel
import wind.android.f5.view.bottom.subview.finance.model.FinanceReportDetailModel

/**
 * # ***********************************************************************************************
 * # ClassName:      IFinanceKeyView$
 * # Function:       财务详情，页面更新接口
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/11/20$    17:14$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
interface IFinanceKeyView : BaseFinanceView {

    /**
     * 更新关键指标页面
     */
    fun updateKeyIndexList(model : FinanceReportDetailModel)

    /**
     * 更新报告期页面
     */
    fun updateFinanceReportList(model: FinanceF9ReportModel)

    /**
     * 更新单季报页面
     */
    fun updateFinanceSeasonList(model: FinanceF9SeasonModel)

    fun showProgress()

    fun hideProgress()

    fun onError()

    /**
     * 展示空页面
     */
    fun showEmptyView()
}