package wind.android.market.business.option.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.TextView
import wind.android.market.R
import wind.android.market.business.option.model.MarketOptionModel

/**
 * # ***********************************************************************************************
 * # ClassName:      MarketOptionAdapter$
 * # Function:       行情-期权列表适配器
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/12/19$    14:40$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class MarketOptionAdapter(var mContext: Context) : BaseAdapter() {

    private var mData = mutableListOf<MarketOptionModel>()

    fun setData(list: MutableList<MarketOptionModel>?) {
        list?.run {
            mData.clear()
            mData.addAll(list)
            notifyDataSetChanged()
        }
    }

    override fun getView(position: Int, convertView: View?, parent: ViewGroup?): View {
        var viewHolder: ViewHolder
        val view: View
        if (convertView == null) {
            view = LayoutInflater.from(mContext).inflate(R.layout.item_market_option, null)
            viewHolder = ViewHolder(view)
            view.tag = viewHolder
        } else {
            view = convertView
        }
        viewHolder = view.tag as ViewHolder
        val item = getItem(position)
        dealViewHold(item, viewHolder)
        return view
    }

    private fun dealViewHold(item: MarketOptionModel?, viewHolder: ViewHolder?) {
        item?.run {
            viewHolder?.securityName?.text = securityName
            viewHolder?.windCode?.text = dealWindCode(mWindCode)
        }
    }

    private fun dealWindCode(windCode: String): String {
        return windCode.substringBefore(".")
    }

    override fun getItem(position: Int): MarketOptionModel? {
        return mData.elementAtOrNull(position)
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    override fun getCount(): Int {
        return mData.size
    }

    private class ViewHolder(itemView: View) {
        var securityName: TextView = itemView.findViewById(R.id.security_name)
        var windCode: TextView = itemView.findViewById(R.id.wind_code)
    }
}