package wind.android.market.business.option.manager

import log.SkyLog
import net.bussiness.SkyFund
import net.listener.ISkyDataListenerEx

/**
 * # ***********************************************************************************************
 * # ClassName:      OptionManager$
 * # Function:       期权-数据请求管理类
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/12/19$    9:24$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class OptionManager {

    fun requestOption(receiver: ISkyDataListenerEx): Int {
        val commandTxt = "report name=Option.OptionList type=[0] exchange=[SSE,SZSE,CFFEX] " +
                "showcolumnname=[_standardContractsName,_uwindCode,_standardContractsCode,_usecurityName,_exchange]";
        val skyLog = SkyLog()
        skyLog.description = "市场-期权列表"
        return SkyFund.sendLongReportCommand(commandTxt, null, 1301, false, skyLog, receiver)
    }

    fun requestOptionMonth(contractCode: String, exchange: String, receiver: ISkyDataListenerEx): Int {
        val commandTxt = "report name=Option.OptionList type=[1] exchange=["+ exchange + "] " +
                "standardContractsCode=[" + contractCode + "] showcolumnname=[_standardContractsCode,_cdMonths,_endTradeDate]"
        val skyLog = SkyLog()
        skyLog.description = "市场-合约月份列表"
        return SkyFund.sendLongReportCommand(commandTxt, null, 1301, false, skyLog, receiver)
    }

    fun requestOptionContent(contractCode: String, exchange: String, date: String, receiver: ISkyDataListenerEx): Int {
        val commandTxt = "report name=Option.OptionList type=[2] exchange=[" + exchange +
                "] standardContractsCode=[" + contractCode + "] cdMonth=[" + date +
                "] showcolumnname=[_windCode,_standardContractsCode,_exName,_cdMonths,_strikePrice," +
                "_direction,_contractUnit,_multiplier]"
        val skyLog = SkyLog()
        skyLog.description = "市场-合约月份列表"
        return SkyFund.sendLongReportCommand(commandTxt, null, 1301, false, skyLog, receiver)
    }
}