package wind.android.market.business.option.view

import net.datamodel.network.RealQuoteItem
import wind.android.market.business.option.model.OptionContentModel
import wind.android.market.business.option.model.OptionDetailModel
import wind.android.market.business.option.model.OptionMonthModel
import wind.android.market.business.option.model.OptionTitleSpeedModel

/**
 * # ***********************************************************************************************
 * # ClassName:      IOptionListView
 * # Function:       期权列表-更新UI接口
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/12/25$    17:16$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
interface IOptionListView {

    /**
     * 初次展示期权列表
     */
    fun setOptionList(list: MutableList<OptionContentModel>)

    /**
     * 更新期权列表
     */
    fun updateOptionList(list: MutableList<RealQuoteItem>)

    /**
     * 更新期权数据
     */
    fun updateOptionItem(item: RealQuoteItem)

    /**
     * 刷新列表视图
     */
    fun refreshOptionList()
}