package wind.android.market.business.option.viewholder

import android.support.v7.widget.RecyclerView
import android.util.SparseArray
import android.view.View

/**
 * # ***********************************************************************************************
 * # ClassName:      MirrorViewHold$
 * # Function:       镜像列表viewholder
 * # @author         ybxie$
 * # @version        Ver 1.0
 * # ***********************************************************************************************
 * # Modified By     ybxie$     2019/12/20$    10:53$
 * # Modifications:  initial
 * # ***********************************************************************************************
 */
class MirrorViewHolder(private val mItemView: View): RecyclerView.ViewHolder(mItemView), View.OnClickListener {

    private val mViewSparseArray = SparseArray<View>()

    private var mOnClickListener:OnMirrorClickListener? = null

    init {
        itemView.setOnClickListener(this)
    }

    fun <T : View> getView(resId: Int): T {
        var view: View? = mViewSparseArray.get(resId)
        if (view == null) {
            view = mItemView.findViewById(resId)
            mViewSparseArray.put(resId, view)
        }
        return view as T
    }

    override fun onClick(v: View?) {
        mOnClickListener?.onClick(adapterPosition)
    }

    fun setOnMirrorClickListener(listener: OnMirrorClickListener) {
        mOnClickListener = listener
    }

    interface OnMirrorClickListener {
        fun onClick(position: Int)
    }
}